using ForwardDiff
#def. del problema in cui si massimizza il rendimento
#con un vincolo sul rischio
n = 3 #number of assets <= 48
m = 2*n+1
p = 1

Q = readdlm("cov48.txt",'\t')
Q = Q[1:48,2:49].*100
Qorig = Q
Q = Q[1:n,1:n]
Q = (Q + Q')./2.0

#read return array
R = readdlm("ret48.txt",'\t')
R = R[:,2]
R = R[1:n].*100
#R = R*100.0
#Q = Q*100.0

sigma = 0.0 # risk must be <= sigma


f_orig(x) = (x'*Q*x)[1]
function nabla_f_orig(x)
	return ForwardDiff.gradient(f_orig,x)
end

function g_orig(x)
	g = zeros(promote_type(eltype(x), Float64), m)
	for i = 1:n
		g[i]   =       x[i] # >= 0
		g[n+i] = 1.0 - x[i] # >= 0
	end
	g[m] = (x'*R)[1] - sigma # >= 0 
	return g
end 
function nabla_g_orig(x)
	return transpose(ForwardDiff.jacobian(g_orig,x))
end

function h_orig(x)
	return sum(x) - 1.0
end
function nabla_h_orig(x)
	return ones(length(x))
end

xzero = ones(n)/n

nothing
